"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isAsyncFunction_1 = __importDefault(require("@/isAsyncFunction/isAsyncFunction"));
const doAsyncLoop = async (array, asyncFunc, options) => {
    let index = -1;
    const length = array == null ? 0 : array.length;
    const result = new Array(length);
    if (options.isParallel) {
        while (++index < length) {
            result[index] = asyncFunc(array[index], index, array);
        }
        return Promise.all(result);
    }
    while (++index < length) {
        result[index] = await asyncFunc(array[index], index, array);
    }
    return result;
};
function mapArray(array, asyncFunc, options = {}) {
    if (isAsyncFunction_1.default(asyncFunc)) {
        return doAsyncLoop(array, asyncFunc, options);
    }
    let index = -1;
    const length = array.length;
    const result = new Array(length);
    while (++index < length) {
        result[index] = asyncFunc(array[index], index, array);
    }
    return result;
}
exports.default = mapArray;
//# sourceMappingURL=mapArray.js.map