"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isAsyncFunction_1 = __importDefault(require("@/isAsyncFunction/isAsyncFunction"));
const doAsyncLoop = async (object, asyncFunc, options) => {
    let index = -1;
    const keys = Object.keys(object);
    if (options.isParallel) {
        const promises = keys.map((key) => asyncFunc(object[key], key, object));
        return Promise.all(promises);
    }
    const result = new Array(keys.length);
    while (++index < keys.length) {
        result[index] = await asyncFunc(object[keys[index]], keys[index], object);
    }
    return result;
};
function mapObject(object, asyncFunc, options = {}) {
    if (isAsyncFunction_1.default(asyncFunc)) {
        return doAsyncLoop(object, asyncFunc, options);
    }
    let index = -1;
    const keys = Object.keys(object);
    const result = new Array(keys.length);
    while (++index < keys.length) {
        result[index] = asyncFunc(object[keys[index]], keys[index], object);
    }
    return result;
}
exports.default = mapObject;
//# sourceMappingURL=mapObject.js.map