"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isAsyncFunction_1 = __importDefault(require("@/isAsyncFunction/isAsyncFunction"));
async function doAsyncLoop(array, asyncFunc) {
    let index = -1;
    const length = array.length;
    while (++index < length) {
        if (await asyncFunc(array[index], index, array) === false) {
            break;
        }
    }
}
function forEach(array, asyncFunc) {
    if (isAsyncFunction_1.default(asyncFunc)) {
        return doAsyncLoop(array, asyncFunc);
    }
    let index = -1;
    const length = array.length;
    while (++index < length) {
        if (asyncFunc(array[index], index, array) === false) {
            break;
        }
    }
}
exports.default = forEach;
//# sourceMappingURL=forEach.js.map