"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const map_1 = __importDefault(require("@/map/map"));
async function asyncFunc(n) {
    return await new Promise((resolve) => {
        resolve(String(n));
    });
}
describe("Map", () => {
    const array = [1, 2];
    it("should map values in collection to a new array", async () => {
        const object = {
            "a": 1,
            "b": 2
        };
        const expected = ["1", "2"];
        chai_1.expect(await map_1.default(array, String)).to.eql(expected);
        chai_1.expect(await map_1.default(object, String)).to.eql(expected);
    });
    it("should map async values in collection to a new array", async () => {
        const object = {
            "a": 1,
            "b": 2
        };
        const expected = ["1", "2"];
        chai_1.expect(await map_1.default(array, asyncFunc)).to.eql(expected);
        chai_1.expect(await map_1.default(object, asyncFunc)).to.eql(expected);
    });
    it("should work with string shorthands", async () => {
        const objects = [{
                "a": "x"
            }, {
                "a": "y"
            }];
        const result = await map_1.default(objects, "a");
        chai_1.expect(result).to.eql(["x", "y"]);
    });
});
//# sourceMappingURL=map.spec.js.map